#!/usr/bin/env python3
# -*- coding: utf-8 -*-


# ====#====#====#====
# author = jys
# file: ut_nitifyConfig.py
# time: 6/8/18
# ====#====#====#====


from leda_python.mbus import MbusBase
import threading
import logging
import json
import os

_logger = logging.getLogger(__name__)


def test_notifyConfig(mbusObject):
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')
    _logger.debug("#################test: notifyConfig################")

    wkn = "iot.driver.abc123"
    objpath = "/iot/driver/abc123"
    interface = wkn

    interfaceHandle = mbusObject.getRemoteInterface(wkn, objpath, interface)
    retInfo = interfaceHandle.notify_config('key', 'value')
    _logger.debug("\tnotifyConfig retInfo: %s  ...Ok", retInfo)
    assert retInfo == 0


if (__name__ == "__main__"):
    logging.basicConfig(level=logging.DEBUG)

    mbusObject = MbusBase("iot.app.demoTest")
    test_notifyConfig(mbusObject)
